Description

This is a guide for setting up master-slave replication with PostgreSQL 9.4 on Debian 8.
NOTE: The example servers will be

1. pg1.example.com as the master at 192.168.0.10
2. pg2.example.com as the slave at 192.168.0.20

Prepare Master Server

e Enable the contrib apt repositories:

sudo sed —-i '' -e 's/main/main\ contrib/' /etc/apt/sources.list
e Make sure the system is up to date:

sudo apt-get update && sudo apt—-get upgrade

e Install postgresql:

sudo apt-get install postgresqgl postgresgl-contrib postgresgl-client rsync

e Set a password for the postgresqgl admin user:

sudo passwd postgres

e Switch to Postgres account:

sudo su - postgres

e Generate ssh key:

ssh-keygen

e Copy SSH key to opposite server:

ssh-copy-id pg2.example.com

NOTE: Make sure to see the postgres password on pg2.example.com before copying the SSH id
® Create an account for replication

psgl —c "CREATE USER replicator REPLICATION LOGIN CONNECTION LIMIT 1 ENCRYPTED PASSWORD

SecretReplicationPassword';"

e Exit from the postgres user:

exit

* Modify postgres access config file:

sudo nano /etc/postgresqgl/9.4/main/pg_hba.conf

o Add content below:

host replication replicator 192.168.0.20/32 md5

® Then modify postgres config file:

sudo nano /etc/postgresql/9.4/main/postgresqgl.conf

o The config value should be:

listen_addresses = 'localhost,192.168.0.10"'
wal_level = 'hot_standby'

archive_mode = on

archive_command = 'cd .'

max_wal_senders 1

hot_standby = on
e Restart Master server:

sudo service postgresql restart

Prepare Slave Server

e Enable the contrib apt repositories:

sudo sed —-i '' -e 's/main/main\ contrib/' /etc/apt/sources.list
e Make sure the system is up to date:

sudo apt-get update && sudo apt—-get upgrade

® Install postgresql:

sudo apt-get install postgresqgl postgresgl-contrib postgresgl-client rsync
e Set a password for the postgresgl admin user:

sudo passwd postgres

e Switch to Postgres account:

sudo su — postgres

e Generate ssh key:

ssh-keygen

e Copy SSH key to opposite server:

ssh-copy-id pgl.example.com

NOTE: Make sure to see the postgres password on pg1.example.com before copying the SSH id

e Create an account for replication

psgl —-c "CREATE USER replicator REPLICATION LOGIN CONNECTION LIMIT 1 ENCRYPTED PASSWORD

SecretReplicationPassword';"

e Exit from the postgres user:

exit

e Stop PostgreSQL:

sudo service postgresgl stop

* Modify postgres access config file:

sudo nano /etc/postgresql/9.4/main/pg_hba.conf

o Add content below:

host replication rep 192.168.0.10/32

* And modify postgres config file:

sudo nano /etc/postgresqgl/9.4/main/postgresqgl.conf

o The config value should be:

listen_addresses = 'localhost,192.168.0.20"'
wal_level = 'hot_standby'

archive_mode = on

archive_command = 'cd .'
max_wal_senders = 1
hot_standby = on

Start the Replication
Master Server

® Begin the replication

sudo su - postgres
psgl -c "select pg_start_backup('initial_backup');"

rsync —-cva —--inplace —--exclude=*pg_xlog* /var/lib/postgresqgl/9.4/main/ -e ssh pg2.example.com:
/var/lib/postgresql/9.4/main/

psgl —-c "select pg_stop_backup();"

exit

Slave Server

e Create recovery.conf file:

sudo nano /var/lib/postgresql/9.4/main/recovery.conf

o And add the content below to that file:

standby_mode = 'on'

primary_conninfo = 'host=192.168.0.10 port=5432 user=replicator password=SuperSecretReplic
ationPassword'

trigger_file = '/tmp/postgresqgl.trigger.5432"

e And restart Slave Server to complete the setup:

sudo service postgresgl start

e Check the postgresql log file:

tail -n 20 /var/log/postgresqgl/postgresqgl-9.4-main.log

o Example output:

2015-11-21 14:47:31 PST [3237-1] LOG: started streaming WAL from primary at 0/19000000 on
timeline 1

2015-11-21 14:47:31 PST [3238-1] [unknown]@[unknown] LOG: incomplete startup packet
2015-11-21 14:47:32 PST [3241-1] postgres@postgres FATAL: the database system is starting
up

2015-11-21 14:47:32 PST [3236-3] LOG: redo starts at 0/19000028

2015-11-21 14:47:32 PST [3236-4] LOG: consistent recovery state reached at 0/19000128
2015-11-21 14:47:32 PST [3235-1] LOG: database system is ready to accept read only connec
tions

Resources
https://sonnguyen.ws/replication-master-slave-with-postgresql-9-4-in-ubuntu-14-04/
https://www.debian-administration.org/article/677/How_to_setup_Postgresqgl_9.1_Streaming_Replication_Debian_Squeeze
https://wiki.postgresqgl.org/index.php?title=Binary Replication_Tutorial#Binary Replication in_6_Steps
http://owocki.com/streaming-replication-postgres-9-4-ubuntu/

https://wiki.postgresqgl.org/wiki/Hot_Standby

History

#1 - 11/20/2015 04:35 PM - Daniel Curtis

- Description updated

#2 - 11/20/2015 05:19 PM - Daniel Curtis
- Description updated

- Status changed from New to In Progress

#3 - 11/21/2015 02:51 PM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

#4 - 11/21/2015 03:11 PM - Daniel Curtis

- Description updated

#5 - 06/04/2017 08:50 PM - Daniel Curtis

- Status changed from Resolved to Closed
